#!/bin/bash

#
#   Day 2 - Exit Code PS1 prompt
#   "Pimp my prompt" with the return value of the last command.
#   source this from ~/.bashrc or similar to modify PS1 to show the return value of previous command.
#   Use the "demojify" command to restore your previous prompt after sourcing.

PS1OLD=$PS1

exitprompt ()
{
    ERROR="$?"
    if [ "$ERROR" -eq 0 ]
    then
        COLORCODE=32 # foreground green
        EMOJI="🙂"
    else
        COLORCODE=31 # foreground red
        EMOJI="🙁"
    fi
    echo -e "\e[${COLORCODE}m${ERROR} ${EMOJI} \e[0m"
}

demojify ()
{
    PS1=$PS1OLD
}

PS1="\$(exitprompt)\n$PS1"

